/** Receive and parse messages from the client-side console relay, and emit them
 * as events. */
/// <reference types="node" />
import http from 'http';
export interface BrowserScriptRelay {
    emitScriptEvent(eventName: string | symbol, ...args: any[]): void;
    filePathToUrl(filePath: string): string | null;
    urlPathToFilePath(urlPath: string): string | null;
    serverUrlToFileUrl(url: string): string | null;
}
export declare function attachBrowserScriptRelay(server: http.Server, relay: BrowserScriptRelay): void;
export declare function replaceUrlsInStack(relay: BrowserScriptRelay, stack: string | undefined): string | undefined;
export declare function injectScriptEventRelayScript(html: string): string;
