/// <reference types="node" />
import express from 'express';
import http = require('http');
import net = require('net');
/** A wrapper for express.Application#listen that returns a Promise.
 *
 * The Promise succeeds if server.address() returns truthy within `interval` ms.
 *
 * It fails if the server sends on 'error' event or fails to produce and address
 * within the specified interval.
 * */
export declare function promiseListen(app: express.Application | http.Server, port?: number, timeout?: number): Promise<http.Server>;
/** A wrapper for http.Server#close that returns a Promise.
 *
 * The Promise succeeds if the server sends a 'close' event within `interval`
 * ms.
 *
 * It fails if the server sends an 'error' event or fails to close within the
 * specified interval.
 */
export declare function promiseClose(server: net.Server, timeout?: number): Promise<void>;
