"use strict";
/** These functions are adapted from https://github.com/sindresorhus/ts-extras.
 *
 * They are here so that I don't have to debug why esbuild-jest produces an
 * error (`SyntaxError: Unexpected token 'export'`) when it tries to compile a
 * file that imports the ts-extras package. (Possibly something that could be
 * fixed via `transformIgnorePatterns`, but the standard
 * "node_modules/(?!(@etc." value did not fix this.)
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.isDefined = exports.assertError = void 0;
const { toString } = Object.prototype;
// Modified from the original to add optional `code` property.
function assertError(value) {
    if (!(value instanceof Error || toString.call(value) === '[object Error]')) {
        throw new TypeError(`Expected an \`Error\`, got \`${JSON.stringify(value)}\` (${typeof value})`);
    }
}
exports.assertError = assertError;
/** Check whether a value is defined (non-nullable), meaning it is neither
 * `null` or `undefined`.
 */
function isDefined(value) {
    return value !== null && value !== undefined;
}
exports.isDefined = isDefined;
